#if !defined(CRITICAL_SEC_)
#define CRITICAL_SEC_
// file		:	critical.cpp
// purpose	:	critical section classes
// (c) Allan Kelly 1998-1999

// System Includes -------------------
// <none>

// Project Includes ------------------
// <none>

// Local includes --------------------
// <none>

#if defined(NAME_SPACES)
namespace Accu
{
#endif

// One critical section is used by multiple threads
class CriticalSection
{
public:
	friend class CriticalToken;

	// create and initialize Critical section
	CriticalSection();

	// destroy critical section
	~CriticalSection();

private:
	void EnterCriticalSection();
	void LeaveCriticalSection();

	// m_pCriticalSection is a void so we do not need
	// to include windows.h in header file 
	// improves compile time and portability
	void *_criticalSection;

	// block default methods
	CriticalSection(const CriticalSection&);
	CriticalSection& operator=(const CriticalSection&);
};

// Critcal section token allocated on entry
// Each thread will have it's own token
class CriticalToken
{
public:
	CriticalToken(CriticalSection &);
	~CriticalToken();

private:
	CriticalSection &_criticalSection;

	// block default methods
	CriticalToken(const CriticalToken&);
	CriticalToken& operator=(const CriticalToken&);
};

#if defined(NAME_SPACES)
}  // namespace
#endif

#endif
