#if !defined(_IOU_THREAD_FUNCTIONS_)
#define _IOU_THREAD_FUNCTIONS_
// file		:	thdfuncs.h
// purpose	:	prototypes for abstract threads
// (c) Allan Kelly 1998-1999

#if defined(NAME_SPACES)
namespace Accu
{
#endif
	struct ThreadTypes
	{
		typedef int (*StartRunFunc) (void*);
		typedef unsigned long int ThreadId;
	};

	struct StartData
	{
		ThreadTypes::StartRunFunc	_startRun;
		void*						_arg;

		StartData(	ThreadTypes::StartRunFunc f, 
					void* a) :	_startRun(f), _arg(a)
		{}
	};

	ThreadTypes::ThreadId CreateThread(	
					ThreadTypes::StartRunFunc	addr,
					void*						arg);


	void WaitForThread(ThreadTypes::ThreadId);
	void DestroyThread(ThreadTypes::ThreadId);

#if defined(NAME_SPACES)
}  // namespace
#endif

#endif
